Unit sfg5e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SFG4E1_p, SFG4E2_p, UTSF11_p;

function sfg5e(A :Extended; X :Extended; EPS :Extended;
                ITMAX :Integer; var IERR :Integer): Real;

implementation

function sfg5e(A :Extended; X :Extended; EPS :Extended;
                ITMAX :Integer; var IERR :Integer): Real;
var
SFG5D,GAMSER,GLN,GAMCFR :Extended;
const
SYS053 :Real = 1.7e308;
label
_10,_20,_30,_40,_50;
begin
{ Result -    SFG5E  FORTRANe }
IERR := 0;
if ( X >= 0.0e0 ) 
 then goto _10;
IERR := 65;
goto _40;
_10:
if ( A > 0.0e0 ) 
 then goto _20;
IERR := 66;
goto _40;
_20:
if ( X >= A+1.0e0 ) 
 then goto _30;
SFG4E1(GAMSER,A,X,GLN,EPS,ITMAX,IERR);
if ( IERR <> 0 ) 
 then goto _40;
Result := 1.0e0-GAMSER;
goto _50;
_30:
SFG4E2(GAMCFR,A,X,GLN,EPS,ITMAX,IERR);
if ( IERR <> 0 ) 
 then goto _40;
Result := GAMCFR;
goto _50;
_40:
Result := SYS053;
UTSF11(IERR,35);
_50:
exit;
end;

end.
