Unit sfg4e2_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF66E_p;

procedure sfg4e2(var GAMCFR :Extended; A :Extended; X :Extended;
                var GLN :Extended; EPS :Extended; ITMAX :Integer;
                var IERR :Integer);

implementation

procedure sfg4e2(var GAMCFR :Extended; A :Extended; X :Extended;
                var GLN :Extended; EPS :Extended; ITMAX :Integer;
                var IERR :Integer);
var
N :Integer;
GOLD,A0,A1,B0,B1,FAC,AN,ANA,ANF,G :Extended;
label
_10,_20,_30;
begin
SF66E(A,GLN,IERR);
GOLD := 0.0e0;
A0 := 1.0e0;
A1 := X;
B0 := 0.0e0;
B1 := 1.0e0;
FAC := 1.0e0;
for N:=1 to ITMAX do
 begin
  AN := ((N));
  ANA := AN-A;
  A0 := (A1+A0*ANA)*FAC;
  B0 := (B1+B0*ANA)*FAC;
  ANF := AN*FAC;
  A1 := X*A0+ANF*A1;
  B1 := X*B0+ANF*B1;
  if ( A1 = 0.0e0 ) 
   then goto _10;
  FAC := 1.0e0/A1;
  G := B1*FAC;
  if ( Abs((G-GOLD)/G) < EPS ) 
   then goto _20;
  GOLD := G;
_10:
 end;
IERR := 67;
goto _30;
_20:
GAMCFR := Exp(-X+A*Ln(X)-GLN)*G;
_30:
end;

end.
